import React from 'react'
import * as mobx from 'mobx'
import {
    inject,
    observer,
} from 'mobx-react'
import {
    WeaTop,
    WeaTab,
    WeaFormItem,
    WeaRightMenu,
    WeaLeftRightLayout,
    WeaLeftTree
} from 'ecCom'
import {
    Row,
    Col,
    Spin,
    Modal,
    Button,
    message,
    Switch
} from 'antd'
import {
    WeaSwitch,
    WeaTableNew
} from 'comsMobx'
import {
    i18n
} from '../../public/i18n';

import '../../style/common.less';

import NewAndEditDialog from '../NewAndEditDialog';
import { renderNoright } from '../../util';



const toJS = mobx.toJS;
const confirm = Modal.confirm;
const WeaTable = WeaTableNew.WeaTable;


@inject('jobGrade')
@observer
export default class JobGrade extends React.Component {
    constructor(props) {
        super(props);
    }

    componentWillMount() {
    }

    componentDidMount() {
        this.init();
    }

    componentWillReceiveProps(nextProps) {
        const {
            jobGrade
        } = this.props;

        if (this.props.location.key !== nextProps.location.key) {
            this.init();
        }
    }

    init() {
        const {
            jobGrade
        } = this.props;
        jobGrade.getHasRight();
        jobGrade.initData();
    }


    getTopMenuBtns() {
        const {
            jobGrade
        } = this.props;
        const {
            topMenu,
            tableStore
        } = jobGrade;

        let btns = [];
        topMenu.map((item, i) => {
            if (item.menuFun !== 'batchDelete') {
                btns.push(<Button type='primary' onClick={() => this.handleClick(item)}>{item.menuName}</Button>);
            } else {
                btns.push(<Button type='primary' onClick={() => this.handleClick(item)} disabled={tableStore.selectedRowKeys.length > 0 ? false : true} >{item.menuName}</Button>);
            }

        });

        return btns;
    }

    handleClick(item) {
        const {
            jobGrade
        } = this.props;
        const {
            isPanelShow
        } = jobGrade;

        isPanelShow && jobGrade.setPanelStatus(false);
        this[item.menuFun] && this[item.menuFun]();
    }

    new() {
        const {
            jobGrade
        } = this.props;

        jobGrade.setNeDialogTitle(i18n.label.newJobGrade());
        jobGrade.setIsNew(true);
        jobGrade.setVisible(true);
        jobGrade.getForm();
    }


    custom = () => {
        const {
            jobGrade
        } = this.props, {
            tableStore,
        } = jobGrade;

        tableStore.setColSetVisible(true);
        tableStore.tableColSet(true);
    }


    batchDelete() {
        const {
            jobGrade
        } = this.props;
        const {
            tableStore
        } = jobGrade;

        let keys = toJS(tableStore.selectedRowKeysAllPages).toString();
        jobGrade.setIds(keys);
        this.showConfirm('batchDel');
    }
    showConfirm(v) {
        let _this = this;
        confirm({
            title: i18n.confirm.defaultTitle(),
            content: (v == 'del') ? i18n.confirm.delete() : i18n.confirm.batchDeleteConfirm(),
            okText: i18n.button.ok(),
            cancelText: i18n.button.cancel(),
            onOk() {
                _this.onOk();
            },
            onCancel() {
                return false;
            },
        });
    }
    onOk() {
        const {
            jobGrade
        } = this.props;
        jobGrade.delete();
    }


    getDropMenuDatas() {
        const {
            jobGrade
        } = this.props;
        const {
            rightMenu
        } = jobGrade;

        let menus = [];
        toJS(rightMenu).map((item, index) => {
            let obj = {
                key: item.menuFun,
                icon: <i className={`${item.menuIcon}`} />,
                content: item.menuName,
            }
            if (item.menuFun == 'collection' || item.menuFun == 'help' || item.menuFun == 'pageAddress') {
                obj.disabled = true;
            }
            menus.push(obj);
        })
        return menus;
    }

    handleMenuClick(key) {
        const {
            jobGrade
        } = this.props;
        const {
            isPanelShow
        } = jobGrade;

        isPanelShow && jobGrade.setPanelStatus(false);
        this[key] && this[key]();
    }

    getTabBtn() {
        const {
            jobGrade
        } = this.props;
        const {
            form2
        } = jobGrade;

        const btn = [
            (<Button ecId={`${this && this.props && this.props.ecId || ''}_Button@bx87i8`} type="primary" onClick={() => {
 jobGrade.getTableInfo(); jobGrade.setPanelStatus(false) 
}}>{i18n.button.search()}</Button>),
            (<Button ecId={`${this && this.props && this.props.ecId || ''}_Button@218ju6`} onClick={() => form2.reset()}>{i18n.button.reset()}</Button>),
            (<Button ecId={`${this && this.props && this.props.ecId || ''}_Button@5u9mfz`} onClick={() => jobGrade.setPanelStatus(false)}>{i18n.button.cancel()}</Button>),
        ];

        return btn;
    }

    onSearchChange(val) {
        const {
            jobGrade
        } = this.props;
        const {
            form2
        } = jobGrade;

        jobGrade.setGradeName(val);
        !this.isEmptyObject(form2.getFormParams()) && jobGrade.updateFields(val);
    }

    changeData(key) {
        const {
            jobGrade
        } = this.props;
        jobGrade.changeData(key);
    }

    reRenderColumns(columns) {
        let _this = this;
        columns.forEach((c, index) => {
            if (c.dataIndex == 'forbidden_tag') {
                c.render = function (text, record) {
                    return <Switch checked={record.forbidden_tag == "0" ? true : false} onChange={checked => _this.updateForbiddenTag(checked, record.id)} />
                }
            };
        })
    }

    updateForbiddenTag(checked, id) {
        const {
            jobGrade
        } = this.props;
        confirm({
            title: i18n.confirm.defaultTitle(),
            content: (checked == true) ? i18n.confirm.enableTag() : i18n.confirm.forbiddenTag(),
            okText: i18n.button.ok(),
            cancelText: i18n.button.cancel(),
            onOk() {
                jobGrade.updateForbiddenTag(checked, id);
            },
            onCancel() {
                return false;
            },
        });
    }

    onOperatesClick(record, rowIndex, operate) {
        const {
            index
        } = operate;
        (index == '0') && this.doEdit(record.randomFieldId);
        (index == '1') && this.doDel(record.randomFieldId);

    }

    doEdit(id) {
        const {
            jobGrade
        } = this.props;

        jobGrade.setNeDialogTitle(i18n.label.editJobGrade());
        jobGrade.setGradeId(id);
        jobGrade.setIsNew(false);
        jobGrade.setVisible(true);
        jobGrade.getForm();
    }

    doDel(id) {
        const {
            jobGrade
        } = this.props;
        jobGrade.setIds(id);
        this.showConfirm('del');
    }


    handleSave() {
        const {
            jobGrade
        } = this.props;
        const {
            isNew
        } = jobGrade;

        isNew && jobGrade.save();
        !isNew && jobGrade.edit();
    }


    log = () => {
        window.setLogViewProp({
            logMoudleType: 3,
            keys: new Date().getTime(),
        });
    }

    getPanelComponents() {
        const {
            jobGrade
        } = this.props;
        const {
            searchCondition,
            form2,
            searchConditionLoading
        } = jobGrade;

        let arr = [];
        let formParams = form2.getFormParams();
        const {
            isFormInit
        } = form2;

        isFormInit && searchCondition.map(c => {
            c.items.map((field, index) => {
                arr.push(<Col ecId={`${this && this.props && this.props.ecId || ''}_Col@4cc308@${index}`} span={(index % 2 == 0) ? 10 : 11} offset={1}>
                    <div style={{ marginTop: 20 }}>
                        <WeaFormItem ecId={`${this && this.props && this.props.ecId || ''}_WeaFormItem@u6ex85@${index}`}
                            label={`${field.label}`}
                            labelCol={{ span: `${field.labelcol}` }}
                            wrapperCol={{ span: `${field.fieldcol}` }}>
                            {<WeaSwitch ecId={`${this && this.props && this.props.ecId || ''}_WeaSwitch@p7d3td@${index}`} fieldConfig={field} form={form2} formParams={formParams} />}
                        </WeaFormItem>
                    </div>
                </Col>)
            })
        })

        if (searchConditionLoading) {
            return (
                <div className='hrm-loading-center-small' style={{ top: '25%' }}>
                    <Spin ecId={`${this && this.props && this.props.ecId || ''}_Spin@lbktzb`} spinning={searchConditionLoading}></Spin>
                </div>
            )
        } else {
            return <Row ecId={`${this && this.props && this.props.ecId || ''}_Row@ppeb6z`} onKeyDown={(e) => {
                if (e.keyCode == 13 && e.target.tagName === "INPUT") {
                    jobGrade.getTableInfo();
                    jobGrade.setPanelStatus(false)
                }
            }}>{arr}</Row>
        }

    }

    //非空判断
    isEmptyObject(obj) {
        for (let key in obj) {
            return false;
        }
        return true;
    }



    render() {

        const {
            jobGrade
        } = this.props;
        const {
            isPanelShow, form2, gradeName, conditionNum, tableStore, nEdialogTitle, visible, condition,
            form, dialogLoading, isEdit, selectedKey, topTab, topTabCount, date, hasRight, treeConfig, treeLoading
        } = jobGrade;

        if (hasRight === false) {
            return renderNoright();
        }

        const {
            data,
            onSelectedTreeNode,
            selectedKeys,
            onExpand,
            treeExpandKeys
        } = toJS(treeConfig);
        const treeCom = (
            hasRight && <WeaLeftTree ecId={`${this && this.props && this.props.ecId || ''}_WeaLeftTree@ifgbi1`}
                datas={data}
                searchLabel={i18n.label.schemeName()}
                onSelect={onSelectedTreeNode}
                selectedKeys={selectedKeys}
                onExpand={onExpand}
                loading={treeLoading}
                expandedKeys={treeExpandKeys} />
        )

        return (
            hasRight && <div ref='page' style={{ height: '100%' }}>
                <WeaRightMenu ecId={`${this && this.props && this.props.ecId || ''}_WeaRightMenu@k6oc4u`}
                    datas={this.getDropMenuDatas()}
                    onClick={key => this.handleMenuClick(key)}
                >
                    <WeaTop ecId={`${this && this.props && this.props.ecId || ''}_WeaTop@bj98s7`}
                        title={i18n.label.gradeName()}
                        icon={<i className='icon-coms-hrm' />}
                        iconBgcolor='#217346'
                        loading={true}
                        buttons={this.getTopMenuBtns()}
                        showDropIcon={true}
                        dropMenuDatas={this.getDropMenuDatas()}
                        onDropMenuClick={(e) => this.handleMenuClick(e)}
                    >
                        <WeaLeftRightLayout ecId={`${this && this.props && this.props.ecId || ''}_WeaLeftRightLayout@q6b87k`} leftCom={treeCom}>
                            <WeaTab ecId={`${this && this.props && this.props.ecId || ''}_WeaTab@9c3zts`}
                                datas={topTab}
                                counts={topTabCount}
                                keyParam="viewCondition" //主键
                                countParam="groupId" //数量
                                selectedKey={selectedKey}
                                onChange={this.changeData.bind(this)}
                                searchType={['base', 'advanced']}
                                showSearchAd={isPanelShow}
                                searchsBaseValue={this.isEmptyObject(form2.getFormParams()) ? gradeName : form2.getFormParams().gradeName}
                                setShowSearchAd={bool => jobGrade.setPanelStatus(bool)}
                                hideSearchAd={() => jobGrade.setPanelStatus(false)}
                                searchsAd={isPanelShow ? this.getPanelComponents() : <div></div>}
                                advanceHeight={Math.ceil(conditionNum / 2) * 52 + 20}
                                hasMask={false}
                                buttonsAd={this.getTabBtn()}
                                onSearch={() => jobGrade.getTableInfo()}
                                onSearchChange={val => this.onSearchChange(val)}
                            />
                            <WeaTable ecId={`${this && this.props && this.props.ecId || ''}_WeaTable@pgmg3x`}
                                comsWeaTableStore={tableStore}
                                hasOrder={true}
                                needScroll={true}
                                getColumns={c => this.reRenderColumns(c)}
                                onOperatesClick={(record, index, operate) => this.onOperatesClick(record, index, operate)}
                            />
                        </WeaLeftRightLayout>
                    </WeaTop>
                </WeaRightMenu>
                <NewAndEditDialog ecId={`${this && this.props && this.props.ecId || ''}_NewAndEditDialog@q4rrwm`}
                    title={nEdialogTitle}
                    visible={visible}
                    condition={toJS(condition)}
                    form={form}
                    isFormInit={form.isFormInit}
                    loading={dialogLoading}
                    isEdit={isEdit}
                    height={280}
                    conditionLen={1}
                    save={() => this.handleSave()}
                    onCancel={() => jobGrade.setVisible(false)}
                    moduleName={"jobGrade"}
                    bindChangeEnvent={val => jobGrade.updateConditions(val)}
                />
            </div>
        )
    }
}